{$R+}
Unit Grafika;
interface

uses dos,crt,graph,poker;
 procedure Inicializuj;
 procedure PrazdnaObrazovka;
 procedure ZobrazPeniazeAText(peniaze,i:integer; s:string);
 procedure ZobrazKopu(Suma:integer);
 Procedure ZobrazKarty(i:integer;Karty:karty);
 procedure ZmazKarty(i:integer);
 procedure Vyhral(i:integer;s:string;Peniaze:integer);
 procedure Tabulka(Peniaze:Pole; s:string);
 procedure Zaver;

 var kreslim:boolean;

implementation

var x, y, xx, yy:integer;

procedure Zaver;
begin
  CloseGraph
end;

procedure Inicializuj;
var Gd, GM:integer;
begin
  gd:=detect;
  InitgRAPH(gd,gm,'');
  xx:=GetMaxX;
  yy:=GetMaxY;
  x:=GetMaxX div PocetHracov;
  y:=(GetMaxY -30) div 7
end;

procedure PrazdnaObrazovka;
var z:integer;
begin
if kreslim then
 begin
  SetBkColor(DarkGray);
  SetFillStyle(SolidFill,black);
  setrgbpalette(blue,0,0,0);
  bar(0,14,xx,4*y+144);
  bar(0,0,xx,13);
  bar(0,4*y+145,xx,yy);
  SetTextJustify(RightText,BottomText);
  SetTextStyle(DefaultFont,HorizDir,1);
  OutTextXY(xx-2,yy-2,'Esc');
  SetTextJustify(CenterText,TopText);
  SetTextStyle(DefaultFont,HorizDir,2);
  for z:=1 to PocetHracov do
    begin
      outTextXY((z-1)*x+(x-85) div 2+42,0,Texty[z])
    end
 end
end;

procedure ZobrazPeniazeAText(peniaze,i:integer; s:string);
var st:string;
begin
 if kreslim then
 begin
  SetTextJustify(CenterText,TopText);
  SetTextStyle(DefaultFont,HorizDir,1);
  str(peniaze,st);
  SetFillStyle(0,6);
  bar((i-1)*x+(x-85) div 2,4*y+145,(i-1)*x+(x-85) div 2+85,4*y+175);
  outTextXY((i-1)*x+(x-85) div 2+42,4*y+145,'$'+st);
  outTextXY((i-1)*x+(x-85) div 2+42,4*y+160,s);
  while keypressed do if readkey=#27 then Kreslim:=not(Kreslim);
  if readkey=#27 then Kreslim:=not(Kreslim);
  bar((i-1)*x+(x-85) div 2,4*y+160,(i-1)*x+(x-85) div 2+85,4*y+175)
 end;
end;

procedure ZobrazKopu(Suma:integer);
var s:string;
begin
 if Kreslim then
 begin
  SetFillStyle(0,6);
  bar(0,yy-20,180,yy-2);
  setTextStyle(DefaultFont,HorizDir,2);
  SetTextJustify(LeftText,BottomText);
  str(suma,s);
  outTextXY(2,yy-2,'Kopa: $'+s);
  setTextStyle(DefaultFont,HorizDir,1)
 end
end;

procedure ZobrazKartu(Karta:Karta;X,Y:integer);
var f:file;
    s:string;
    p:pointer;
    z:word;
begin
  case ord(Karta.Hodnota) of
    0..8:str(ord(Karta.Hodnota)+2,s);
    9 : s:='J';
    10: s:='Q';
    11: S:='K';
    12: S:='A'
  end;
  s:=''+s+'_';
  case ord(Karta.Farba) of
   0: s:=s+'C';  {cross=zalud}
   1: s:=s+'D';  {diamond=gula}
   2: s:=s+'H';  {heart=srdce}
   3: s:=s+'S'   { zelen}
  end;
  s:=s+'.sml';
  assign(f,s);
  reset(f,1);      {pozri path 8 riadkov vyssie}
  z:=filesize(f);
  getmem(p,z);
  blockread(f,p^,z);
  close(f);
  putimage(x,y,p^,normalput);
  freemem(p,z)
end;

Procedure ZobrazKarty(i:integer;Karty:karty);
var j:integer;
begin
 if kreslim then
   for j:=0 to 4 do
     ZobrazKartu(Karty[j+1],(i-1)*x+(x-85) div 2,j*y+15)  {karta 85*125}
end;

procedure ZmazKarty(i:integer);
begin
 {  karty su od (i-1)*x+(x-85) div 2,15
             do (i-1)*x+(x-85) div 2+85,4*y+145   Karta(85*125)}
 if kreslim then
  bar((i-1)*x+(x-85) div 2,15,
       (i-1)*x+(x-85) div 2+85,4*y+140);
end;

procedure Vyhral(i:integer;s:string;Peniaze:integer);
var st:string;
begin
 if Kreslim then
 begin
  SetFillStyle(0,0);
  bar(181,yy-12,xx-100,yy-2);
  SetTextJustify(CenterText,BottomText);
  str(Peniaze,st);
  outTextXY(xx div 2,yy-2,Texty[i]+s+st);
  while keypressed do if readkey=#27 then Kreslim:=not(Kreslim);
  if readkey=#27 then Kreslim:=not(Kreslim);
  bar(181,yy-12,xx-100,yy-2)
 end
end;

procedure Tabulka(Peniaze:Pole; s:string);
var Poradie:Pole;
    i,j,max,p,y:LongInt;
begin
   clearDevice;
   SetTextJustify(CenterText,TopText);
   SetTextStyle(DefaultFont,HorizDir,3);
   outTextXY(xx div 2,2,s);
   {  s ... 'Vysledky kola'
        ... 'Konecne vysledky' }
   for i:=1 to PocetHracov do Poradie[i]:=i;
   for i:=1 to PocetHracov-1 do
     begin
        max:=Peniaze[i]; p:=i;
        for j:=i+1 to PocetHracov do
          if Peniaze[j]>max then
            begin max:=Peniaze[j]; p:=j
            end;
        Peniaze[p]:=Peniaze[i];
        Peniaze[i]:=max;
        Max:=Poradie[p];
        Poradie[p]:=Poradie[i];
        Poradie[i]:=max
     end;
   y:=yy div (PocetHracov+1);
   p:=y;
   inc(y,2); i:=1;
   str(i,s);
      SetTextJustify(LeftText,TopText);
   SetColor(white);
   outTextXY(2,y,s+'.');
   OutTextXY(60,y,Texty[poradie[i]]);
   str(Peniaze[i],s);
   SetTextJustify(rightText,TopText);
   OutTextXY(xx-100,y,s);
   SetTextJustify(LeftText,TopText);
   inc(y,p);
   for i:=2 to PocetHracov do
     begin
       str(i,s);
       if peniaze[i]<>peniaze[i-1] then
          outTextXY(2,y,s+'.');
       OutTextXY(60,y,Texty[poradie[i]]);
       str(Peniaze[i],s);
       SetTextJustify(rightText,TopText);
       OutTextXY(xx-100,y,s);
       SetTextJustify(LeftText,TopText);
       inc(y,p)
     end;
   while keypressed do if readkey=#121 then ;
   if readkey=#27 then Kreslim:=not(Kreslim)
end;

begin
  Kreslim:=true
end.
