unit Hrac1;

interface

uses Poker;
var MojeKarty:Karty;
    PocetZhod, MojePeniaze:Integer;
procedure TuMasKartyAPeniaze(Karty:Karty;Peniaze:integer);
function Licitacia(Prihodil:Pole;suma:integer):integer;
procedure Zhod(var Pocet:integer;var Karty:karty);
procedure ZoberNove(Zhodil:Pole;var Karty:karty);
procedure UkazVsetkyKarty(VsetkyKarty:VsetkyKartyHracov);

{************************************************************}
implementation

type stavy = 1..10;

var lic1:1..2;
    stav21:stavy;
    dvai1,trii1:0..5;
    farba21:farba;
    pocet1:byte;

procedure vymen(i1,i2:byte);
var pom:karta;
begin
  pom:=mojekarty[i1];
  mojekarty[i1]:=mojekarty[i2];
  mojekarty[i2]:=pom;
end;

function stav : stavy;
var i,l,kde:0..5;

function je3:boolean;
begin
  trii1:=0;
  repeat
    inc(trii1);
  until (trii1=3) or
    ((mojekarty[trii1].hodnota=mojekarty[trii1+1].hodnota) and
     (mojekarty[trii1+1].hodnota=mojekarty[trii1+2].hodnota));
  je3:=(mojekarty[trii1].hodnota=mojekarty[trii1+1].hodnota) and
       (mojekarty[trii1+1].hodnota=mojekarty[trii1+2].hodnota);
end;

function je2:boolean;
begin
  dvai1:=0;
  repeat
    inc(dvai1);
  until (dvai1=4) or (mojekarty[dvai1].hodnota=mojekarty[dvai1+1].hodnota);
  je2:=mojekarty[dvai1].hodnota=mojekarty[dvai1+1].hodnota;
end;

function budeflash:boolean;
var pom3:farba;
    i:byte;
    pom2:array[farba]of byte;
begin
  for pom3:=zalud to zelen do
    pom2[pom3]:=0;
  for i:=1 to 5 do
    inc(pom2[mojekarty[i].farba]);
  if pom2[gula]>=pom2[zalud] then
    farba21:=gula
  else
    farba21:=zalud;
  if pom2[cerven]>=pom2[farba21] then
    farba21:=cerven;
  if pom2[zelen]>=pom2[farba21] then
    farba21:=zelen;
  budeflash:=pom2[farba21]>=4;
end;

begin
  for i:=1 to 4 do
    begin
      kde:=i;
      for l:=i+1 to 5 do
        if mojekarty[l].hodnota<mojekarty[kde].hodnota then
          kde:=l;
      if kde<>i then
        vymen(i,kde);
    end;
  if  (mojekarty[2].hodnota=mojekarty[3].hodnota) and         { POKER }
      (mojekarty[3].hodnota=mojekarty[4].hodnota) and
     ((mojekarty[1].hodnota=mojekarty[2].hodnota) or
      (mojekarty[4].hodnota=mojekarty[5].hodnota)) then
    stav:=8
  else
    if ((((succ(mojekarty[1].hodnota)=mojekarty[2].hodnota) and { POST. }
          (succ(mojekarty[4].hodnota)=mojekarty[5].hodnota)) or
         ((mojekarty[5].hodnota=a) and (mojekarty[1].hodnota=dva))) and
          (succ(mojekarty[2].hodnota)=mojekarty[3].hodnota) and
          (succ(mojekarty[3].hodnota)=mojekarty[4].hodnota)) or
       ((mojekarty[1].farba=mojekarty[2].farba) and           { FLUSH }
        (mojekarty[2].farba=mojekarty[3].farba) and
        (mojekarty[3].farba=mojekarty[4].farba) and
        (mojekarty[4].farba=mojekarty[5].farba)) or
       ( (mojekarty[1].hodnota=mojekarty[2].hodnota) and      { FULL HOUSE }
         (mojekarty[4].hodnota=mojekarty[5].hodnota) and
        ((mojekarty[2].hodnota=mojekarty[3].hodnota) or
         (mojekarty[3].hodnota=mojekarty[4].hodnota))) then
      if mojekarty[5].hodnota<osem then
        stav:=10
      else
        stav:=7
    else
      if je3 then                                             { 3 }
        if mojekarty[3].hodnota>=desat then
          stav:=6
        else
          stav:=9
      else
        if je2 then
          if (dvai1<=2) and ((mojekarty[3].hodnota=mojekarty[4].hodnota) or
                             (mojekarty[4].hodnota=mojekarty[5].hodnota)) then
            if mojekarty[4].hodnota>=desat then                   { 2+2 }
              stav:=5
            else
              stav:=3
          else                                                { 2 }
            if mojekarty[dvai1].hodnota>=desat then
              stav:=3
            else
              if budeflash then
                stav:=1
              else
                stav:=4
        else                                                  { NIC }
          if budeflash then
            stav:=1
          else
            stav:=2;
end;

procedure TuMasKartyAPeniaze(Karty:Karty;Peniaze:integer);
begin {je dolezite si ich uchovat}
   MojeKarty:=Karty;
   lic1:=1;
   MojePeniaze:=Peniaze;
   stav21:=stav;
   inc(pocet1);
end;

function Licitacia(Prihodil:Pole;suma:integer):integer;
var max,i:1..5;

function mampeniaze(kolko:byte):boolean;
begin
  mampeniaze:=mojepeniaze-100*(1-(pocet1 div pocethier))>suma+kolko;
end;

begin {niekto uz dal na sumu (suma) a co ty na to}
      {v poli Prihodil je, kto kolko prihodil}
    { -1  vzdavam  (drop)}
    {  0  zarovnavam     }
    { >0  zarovnavam a nadhadzujem tuto sumu }
    max:=1;
    for i:=2 to 5 do
      if prihodil[i]>prihodil[max] then
        max:=i;
    case stav21 of
      1:if lic1=1 then
          if mampeniaze(0) then
            licitacia:=0
          else
            licitacia:=-1
        else
          if (max>0) or not(mampeniaze(0)) then
            licitacia:=-1
          else
            licitacia:=0;
      2:if lic1=1 then
          if mampeniaze(0) then
            licitacia:=0
          else
            licitacia:=-1
        else
          if (max>0) or not(mampeniaze(0)) then
            licitacia:=-1
          else
            licitacia:=0;
      3:if lic1=1 then
          if mampeniaze(0) then
            licitacia:=0
          else
            licitacia:=-1
        else
          if (suma<50) and (max<=30) then
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1
          else
            licitacia:=-1;
      4:if lic1=1 then
          if mampeniaze(0) then
            licitacia:=0
          else
            licitacia:=-1
        else
          if (max>0) or not(mampeniaze(0)) then
            licitacia:=-1
          else
            licitacia:=0;
      5:if lic1=1 then
          if (suma<100) and (max<=40) then
            if mampeniaze(20) then
              licitacia:=20
            else
              if mampeniaze(0) then
                licitacia:=0
              else
                licitacia:=-1
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1
        else
          if (suma<150) and (max<=40) then
            if mampeniaze(20) then
              licitacia:=20
            else
              if mampeniaze(0) then
                licitacia:=0
              else
                licitacia:=-1
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1;
      6:if lic1=1 then
          if (suma<100) and (max<=50) then
            if mampeniaze(25) then
              licitacia:=25
            else
              if mampeniaze(0) then
                licitacia:=0
              else
                licitacia:=-1
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1
        else
          if (suma<150) and (max<=50) then
            if mampeniaze(20) then
              licitacia:=20
            else
              if mampeniaze(0) then
                licitacia:=0
              else
                licitacia:=-1
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1;
      7:if lic1=1 then
          if mampeniaze(50) then
            licitacia:=50
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1
        else
          if mampeniaze(70) then
            licitacia:=70
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1;
      8:if lic1=1 then
          if mampeniaze(50) then
            licitacia:=50
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1
        else
          if mampeniaze(70) then
            licitacia:=70
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1;
      9:if lic1=1 then
          if (suma<70) and (max<=45) then
            if mampeniaze(10) then
              licitacia:=10
            else
              if mampeniaze(0) then
                licitacia:=0
              else
                licitacia:=-1
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1
        else
          if (suma<150) and (max<=45) then
            if mampeniaze(10) then
              licitacia:=10
            else
              if mampeniaze(0) then
                licitacia:=0
              else
                licitacia:=-1
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1;
      10:if lic1=1 then
          if mampeniaze(20) then
            licitacia:=20
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1
        else
          if mampeniaze(20) then
            licitacia:=20
          else
            if mampeniaze(0) then
              licitacia:=0
            else
              licitacia:=-1;
    end;
end;

procedure Zhod(var Pocet:integer;var Karty:karty);
var i:0..5;
begin  {vyber si karty, ktore chces zhodit, do Pocet daj ich pocet
        a karty zapis do pola Karty (na prvych Pocet miest)}
   case stav21 of
     1:begin
         i:=0;
         repeat
           inc(i);
         until mojekarty[i].farba<>farba21;
         if i<>1 then
           vymen(1,i);
         pocet:=1;
       end;
     2:pocet:=3;
     3:begin
         if dvai1=1 then
           if mojekarty[3].hodnota=mojekarty[4].hodnota then
             vymen(3,5);
         if mojekarty[4].hodnota<>mojekarty[5].hodnota then
           begin
             vymen(dvai1,5);
             if dvai1<>3 then
               vymen(dvai1+1,4);
           end;
         pocet:=3;
       end;
     4:begin
         if dvai1<=2 then
           begin
             vymen(dvai1,4);
             if dvai1<>2 then
               vymen(dvai1+1,3);
           end;
         pocet:=2;
       end;
     5:begin
         if mojekarty[1].hodnota=mojekarty[2].hodnota then
           if mojekarty[3].hodnota=mojekarty[4].hodnota then
             vymen(1,5)
           else
             vymen(1,3);
         pocet:=1;
       end;
     6:begin
         if trii1<=2 then
           begin
             vymen(trii1,5);
             if trii1<>2 then
               vymen(trii1+1,4);
           end;
         pocet:=2;
       end;
     7:pocet:=0;
     8:begin
         if mojekarty[1].hodnota=mojekarty[3].hodnota then
           vymen(1,5);
         pocet:=1;
       end;
     9:begin
         if trii1<=2 then
           begin
             vymen(trii1,5);
             if trii1<>2 then
               vymen(trii1+1,4);
           end;
         pocet:=2;
       end;
     10:pocet:=0;
   end;
   Karty:=MojeKarty;
   PocetZhod:=Pocet;
end;

procedure ZoberNove(Zhodil:Pole;var Karty:karty);
var i:integer;
  {v poli Zhodil je, kto kolko zhodil kariet}
begin  {zober si nove namiesto zhodenych}
  mojekarty:=karty;
  lic1:=2;
  stav21:=stav;
end;

procedure UkazVsetkyKarty(VsetkyKarty:VsetkyKartyHracov);
begin
end;

{*****************Implementation**************}
begin
  pocet1:=0;
end.
