unit Hrac4;

{$D+,L+,X+}

interface

uses Poker,Crt,Graph;
var MojeKarty:Karty;
    PocetZhod, MojePeniaze:Integer;
procedure TuMasKartyAPeniaze(Karty:Karty;Peniaze:integer);
function Licitacia(Prihodil:Pole;suma:integer):integer;
procedure Zhod(var Pocet:integer;var Karty:karty);
procedure ZoberNove(Zhodil:Pole;var Karty:karty);
procedure UkazVsetkyKarty(VsetkyKarty:VsetkyKartyHracov);

Const MaxLicit=100;
      JaSom=4;
      MinLimit=220;
      MaxZvys:Word=10;  {max. pocet zvyseni - potom zarovnava}

{***********************************************************}
implementation

Var Blufuje:Array [1..PocetHracov] Of Byte; {v kolkych %}
    PocHier,PocBluf:Array [1..PocetHracov] Of Word;
    KolkoDal:Array [1..PocetHracov] Of Word;   {kolko dal celkovo}
    TotDal:Array [1..PocetHracov] Of Word;     {kolko dal vo vsetkych hrach}
    PocLic:Word;
    BoloZvyseni:Word;
    BolaVymena:Boolean;

{ $DEFINE Debug}

Var MK:Karty Absolute MojeKarty;
    PosledneDal:Integer;
    Body:Word;
    {$IFDEF Debug}
    S,S1,S2,S3,S4,S5:String[30];
    {$ENDIF}
      {pre informaciu:
            0= vyhrava ten, kto ma najvacsiu kartu
            3= 2
            6= 2+2
            7= 3
            8= spinava postupka
            9= flush = 5 rovnakej farby
            10= full house = 3+2
            11= poker  = 4
            17= straight flush = cista postupka
      }

Var PZhod:Integer;

Procedure UpravKarty;

  Procedure SortKarty;
    Var I,J:Word;
        PK:Karta;

    Function Hodn(I:Word):Word;
      Begin
        Hodn:=Ord(MK[I].Hodnota)*4+Ord(MK[I].Farba);
      End;

    Begin
      For I:=1 To 4 Do
        For J:=I+1 To 5 Do
          If Hodn(J)<Hodn(I) Then Begin
            PK:=MK[I];MK[I]:=MK[J];MK[J]:=PK;
          End;
    End;

  Procedure TestNTice;
    Var DecCount:Word;
        I:Word;

    Procedure Rotuj(SC,NP:Word);  {rotuje od SC smerom k jednotke, NP karat}
      Var PK:Karta;
          I:Word;
      Begin
        PK:=MK[SC];
        For I:=SC DownTo SC-NP+2 Do MK[I]:=MK[I-1];
        MK[SC-NP+1]:=PK;
      End;

    Function TestXTica(I:Integer):Integer;
      Var PP,J:Word;
      Begin
        TestXTica:=0;
        If MK[I].Hodnota<>MK[I-1].Hodnota Then Begin
          Inc(DecCount);
          Exit;
        End;
        PP:=1;
        While (PP<I) And (MK[I].Hodnota=MK[I-PP].Hodnota) Do Inc(PP);
        If DecCount>0 Then Begin
          For J:=1 To DecCount Do Rotuj(I+DecCount,PP+DecCount);
        End;
        TestXTica:=PP-1;
        Case PP Of
          2:Inc(Body,3);
          3:Inc(Body,7);
          4:Inc(Body,11);
        End;
        Dec(PocetZhod,PP);
      End;

    Function JePostupka:Boolean;
      Var B:Boolean;
          I:Word;
      Begin
        B:=True;
        For I:=1 To 4 Do
          B:=B And (Ord(MK[I+1].Hodnota)-Ord(MK[I].Hodnota)=1);
        JePostupka:=B;
        If B Then Inc(Body,8);
      End;

    Function JeFlash:Boolean;
      Var B:Boolean;
          I:Word;
      Begin
        B:=True;
        For I:=1 To 4 Do
          B:=B And (Ord(MK[I].Farba)=Ord(MK[5].Farba));
        JeFlash:=B;
        If B Then Inc(Body,9);
      End;

    Function JeTemerFlash:Boolean;
      Var C,PP,PS:Word;
          I:Word;
          PK:Karta;
      Begin
        C:=0;
        For I:=1 To 4 Do
          C:=C+Ord(Ord(MK[I].Farba)=Ord(MK[5].Farba));
        PP:=5;
        If C=0 Then Begin
          For I:=2 To 5 Do
            C:=C+Ord(Ord(MK[I].Farba)=Ord(MK[1].Farba));
          PP:=1;
        End;
        For I:=1 To 5 Do If Ord(MK[I].Farba)<>Ord(MK[PP].Farba)
          Then PS:=I;
        JeTemerFlash:=C=3;
        If (C=3) And (PS>1) Then Begin
          {PS dat do MK[1]}
          PK:=MK[1];
          MK[1]:=MK[PS];
          MK[PS]:=PK;
        End;
      End;

    Function JeTemerPostupka:Boolean;
      Var PK:Karty;
          I,J:Word;
          B:Boolean;
      Begin
        JeTemerPostupka:=False;
        For I:=1 To 5 Do Begin
          PK:=MojeKarty;
          If I>2 Then Begin
            For J:=I DownTo 2 Do
              PK[J]:=PK[J-1];
            PK[1]:=MK[I];
          End;
          B:=True;
          For J:=3 To 5 Do B:=B And (Ord(PK[J].Hodnota)-
                      Ord(PK[J-1].Hodnota)=1);
          If B {mame temer postupku} Then
            Begin
              MK:=PK;
              PocetZhod:=1;
            End;
        End;
      End;

    Begin
      PocetZhod:=5;DecCount:=0;
      I:=5;
      Repeat
        Dec(I,TestXTica(I)+1);
      Until I<2;
      If PocetZhod=5 Then Begin
        If JePostupka Or JeFlash Then PocetZhod:=0
          Else If JeTemerFlash Or JeTemerPostupka Then PocetZhod:=1
      End;
    End;

  Begin
    {upravi karty, tie co su na zaciatku (max. pocetzhod) sa smu zhodit}
    Body:=0;
    SortKarty;
    TestNTice;
    BoloZvyseni:=0;
    Case Body Of
      0..6:MaxZvys:=2;
      7..8:MaxZvys:=3;
      9:MaxZvys:=4+Random(2);
      10:MaxZvys:=7+Random(4);
      11:MaxZvys:=10;
      12..17:MaxZvys:=12;
    End;
  End;

procedure TuMasKartyAPeniaze(Karty:Karty;Peniaze:integer);
begin {je dolezite si ich uchovat}
   MojeKarty:=Karty;
   MojePeniaze:=Peniaze;
   UpravKarty;
   PosledneDal:=0;
   FillChar(KolkoDal,SizeOf(KolkoDal),0);
   PocLic:=0;  {pocet licitacii}
   BolaVymena:=False;
end;

function Licitacia(Prihodil:Pole;suma:integer):integer;

Var FL:Integer;

Function Blufuj:Boolean;
  Begin
    Blufuj:=Random(20)=10;
  End;

Function Rand(P1,P2:Integer):Integer;
  Var P:Integer;
  Begin
    P:=Random(101);
    While (P<P1) Or (P>P2) Do P:=Random(101);
    Rand:=P*MaxLicit Div 100;
  End;

Function Perc(P:Integer):Integer;
  Begin
    Perc:=P*MaxLicit Div 100;
  End;

Var Suma2,I,BoloZBlufu:Integer;

begin {niekto uz dal na sumu (suma) a co ty na to}
      {v poli Prihodil je, kto kolko prihodil}
    { -1  vzdavam  (drop)}
    {  0  zarovnavam     }
    { >0  zarovnavam a nadhadzujem tuto sumu }
    Inc(PocLic);
    For I:=1 To PocetHracov Do
      If Prihodil[I]>0 Then Inc(KolkoDal[I],Prihodil[I]);
    randomize;
    Suma2:=Suma-PosledneDal;
    BoloZBlufu:=0;
    For I:=1 To PocetHracov Do If I<>JaSom Then If Prihodil[I]>0 Then
        Inc(BoloZBlufu,Prihodil[I]*Blufuje[I] Div 100);
    FL:=0;
    If (PocetZhod=5) And (Suma2>0) And BolaVymena Then Begin
      Licitacia:=-1;  {vzdal sa - je po vymene, nema slusne karty}
      Exit;
    End;
    If PocetZhod=0 Then Begin
      Case Body Of
        8:FL:=Rand(20,80);   {spin.post.}
        9:FL:=Rand(30,100);
        10:FL:=Rand(50,100);
        17:FL:=Rand(80,100);
        Else Begin
          FL:=Rand(20,100);
        End;
      End;
    End Else Begin
      Case PocetZhod Of
        1:If Body=11 Then FL:=Rand(80,100) Else Begin
            BoloZBlufu:=0;
            If Random(10)<3 Then FL:=Rand(0,10) Else FL:=0;
          End;
        2:If Random(5)<3 Then FL:=Rand(10,30);
        3:Begin
            BoloZBlufu:=BoloZBlufu Div 2;
            If Suma2-BoloZBlufu<Perc(55) Then
              If MK[5].Hodnota>=K Then FL:=0
                Else If (Random(3)=1) Or (Suma2-BoloZBlufu<Perc(15)) Then
                  FL:=0 Else FL:=-1
            Else If Random(3)=1 Then FL:=0 Else FL:=-1;
          End;
        Else Begin
          BoloZBlufu:=BoloZBlufu Div 3;
          If Blufuj Then FL:=Rand(0,10) Else
            If Suma2-BoloZBlufu<Perc(15) Then FL:=0 Else FL:=-1;
        End;
      End;
    End;
    If (MojePeniaze<=MinLimit) And (FL>0) Then FL:=0; {aby nezvysoval donekonecna}
    {$IFDEF Debug}
    SetFillStyle(1,1);
    Bar(280,GetMaxY-40,540,GetMaxY-32);
    SetColor(15);Str(FL,S);
    Str(Suma,S1);
    Str(Suma2,S2);
    Str(MojePeniaze,S3);
    Str(PosledneDal,S4);
    Str(BoloZBlufu,S5);
    OutTextXY(410,GetMaxY-39,S+',S'+S1+',m'+S2+',Mp'+S3+',P'+S4+','+S5+';');
    ReadKey;
    {$ENDIF}
    If (Suma2-BoloZBlufu>FL) And (FL>=0) Then
      If Random(4)=0 Then FL:=0 Else
        FL:=FL Div 2  {pokial niekto zvysil o viac ako som}
                            {chcel zvysit ja}
      Else If Suma2-BoloZBlufu>0 Then
        FL:=FL-Suma2+BoloZBlufu; {doplnit zvysenie na take,}
                                 {ake som chcel, ked uz niekto zvysil}
    If FL=0 Then BoloZvyseni:=0 Else
      If BoloZvyseni=MaxZvys Then FL:=0
        Else If BoloZvyseni>MaxZvys Then FL:=0
          Else Inc(BoloZvyseni);
    If FL+Suma2>MojePeniaze Then Begin
      FL:=MojePeniaze-Suma2;
      If FL<0 Then FL:=-1;  {nemam peniaze}
    End;
    If FL>=0 Then Dec(MojePeniaze,Suma2+FL);  {odpocitat si}
    Licitacia:=FL;
    Inc(PosledneDal,Suma2+FL);
end;

procedure Zhod(var Pocet:integer;var Karty:karty);
begin  {vyber si karty, ktore chces zhodit, do Pocet daj ich pocet
        a karty zapis do pola Karty (na prvych Pocet miest)}
   Karty:=MojeKarty;
   If PocetZhod<>0 Then
     PZhod:=PZhod;
   Case PocetZhod Of
     0:PZhod:=0;
     1:If Body<=6 Then If Random(2)=0 Then PZhod:=3 Else PZhod:=1
         Else PZhod:=1;
     2:PZhod:=2;
     3:PZhod:=2+Random(2);
     Else If Random(5)=1 Then PZhod:=PocetZhod Else
       PZhod:=PocetZhod;
   End;
   Pocet:=PZhod;
   randomize;
end;

procedure ZoberNove(Zhodil:Pole;var Karty:karty);
var i:integer;
  {v poli Zhodil je, kto kolko zhodil kariet}
begin  {zober si nove namiesto zhodenych}
  MojeKarty:=Karty;
{  for i:=1 to PZhod do MojeKarty[i]:=Karty[i];}
  UpravKarty;
  BolaVymena:=True;
end;

procedure UkazVsetkyKarty(VsetkyKarty:VsetkyKartyHracov);
  Var I,PRH:Word;

  Function KH(K:Karta):Word;
    Begin
      KH:=Ord(K.Hodnota)*4+Ord(K.Farba);
    End;

begin
{ak su same rovnake, tak tento vzdal}
  For I:=1 To PocetHracov Do
    If KH(VsetkyKarty[I,1])<>KH(VsetkyKarty[I,2]) Then {hral}
      Begin
        Inc(PocHier[I]);
        MK:=VsetkyKarty[I];
        UpravKarty;  {kolko mal bodov na ruke}
        Case Body Of
          0..6:PRH:=30;
          7..8:PRH:=50;
          9..10:PRH:=100;
          11..17:PRH:=100;
        End;
        If KolkoDal[I]>PRH*PocLic Then Inc(PocBluf[I]);
        Blufuje[I]:=Round(PocBluf[I]/PocHier[I]*100);
      End;
  For I:=1 To PocetHracov Do Inc(TotDal[I],KolkoDal[I]);
end;

Var OldExit:Pointer;

Procedure NewExit; Far;
  Var I:Word;
  Begin
    ExitProc:=OldExit;
    If ErrorAddr=NIL Then Begin
      ClrScr;
      WriteLn('Statistika:');
      For I:=1 To PocetHracov Do If PocHier[I]>0 Then Begin
        WriteLn('  ',I,'. blufoval v ',PocBluf[I]/PocHier[I]*100:5:1,'% hier.',
           '   Celkovo prihodil:',TotDal[I]:5);
      End;
      WriteLn('                                 (C) Hrac 4 - Mizove druzstvo');
    End;
  End;

{*****************Implementation**************}
begin
  randomize;
  FillChar(Blufuje,SizeOf(Blufuje),0);
  FillChar(PocBluf,SizeOf(PocBluf),0);
  FillChar(PocHier,SizeOf(PocHier),0);
  FillChar(TotDal,SizeOf(TotDal),0);
  OldExit:=ExitProc;
  ExitProc:=@NewExit;
end.
